/*********************************************************************
 * Author: Malte Helmert (helmert@informatik.uni-freiburg.de)
 * (C) Copyright 2003-2004 Malte Helmert
 *
 * This file is part of LAMA.
 *
 * LAMA is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the license, or (at your option) any later version.
 *
 * LAMA is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 *********************************************************************/

#include <cassert>
using namespace std;

#include "search_engine.h"

SearchEngine::SearchEngine() {
	solved = false;
}

SearchEngine::~SearchEngine() {
}

void SearchEngine::statistics() const {
}

bool SearchEngine::found_solution() const {
	return solved;
}

const SearchEngine::Plan &SearchEngine::get_plan() const {
	assert(solved);
	return plan;
}

void SearchEngine::set_plan(const Plan &p) {
	solved = true;
	plan = p;
}

SearchEngine::Trajectory &SearchEngine::get_trajectory()  {
	assert(solved);
	return trajectory;
}

void SearchEngine::set_trajectory(const Trajectory &t) {
	solved = true;
	trajectory = t;
}

void SearchEngine::search() {
	initialize();
	solved = false;
	while ( step() == IN_PROGRESS)
		;
}

/*
const vector<State* >& SearchEngine::get_states() const {
	assert(solved);
}
*/
